searchData={"items":[{"type":"module","title":"BackBreeze","doc":"The main module for BackBreeze, containing some helper functions.","ref":"BackBreeze.html"},{"type":"function","title":"BackBreeze.screen_dimensions/1","doc":"Return the screen dimensions. Use the terminal dimensions if specified\notherwise calculate using the `:io` module.","ref":"BackBreeze.html#screen_dimensions/1"},{"type":"module","title":"BackBreeze.Border","doc":"Helper functions for generating borders.","ref":"BackBreeze.Border.html"},{"type":"function","title":"BackBreeze.Border.bottom/1","doc":"Set the bottom border glyph.","ref":"BackBreeze.Border.html#bottom/1"},{"type":"function","title":"BackBreeze.Border.custom/1","doc":"Return a custom border by providing the individual glyphs.","ref":"BackBreeze.Border.html#custom/1"},{"type":"function","title":"BackBreeze.Border.invisible/0","doc":"Return an invisible border.","ref":"BackBreeze.Border.html#invisible/0"},{"type":"function","title":"BackBreeze.Border.left/1","doc":"Set the left border glyph.","ref":"BackBreeze.Border.html#left/1"},{"type":"function","title":"BackBreeze.Border.line/0","doc":"Return a line border.","ref":"BackBreeze.Border.html#line/0"},{"type":"function","title":"BackBreeze.Border.none/0","doc":"Return an empty border.","ref":"BackBreeze.Border.html#none/0"},{"type":"function","title":"BackBreeze.Border.render_bottom/2","doc":"Render a bottom border of the specified width.\n\n```elixir\niex> BackBreeze.Border.line() |> BackBreeze.Border.render_top(10)\n\"┌──────────┐\n\"\n```","ref":"BackBreeze.Border.html#render_bottom/2"},{"type":"function","title":"BackBreeze.Border.render_left/1","doc":"Render a left border.\n\n```elixir\niex> BackBreeze.Border.line() |> BackBreeze.Border.render_left()\n\"│\"\n```","ref":"BackBreeze.Border.html#render_left/1"},{"type":"function","title":"BackBreeze.Border.render_right/1","doc":"Render a right border.\n\n```elixir\niex> BackBreeze.Border.line() |> BackBreeze.Border.render_right()\n\"│\"\n```","ref":"BackBreeze.Border.html#render_right/1"},{"type":"function","title":"BackBreeze.Border.render_top/2","doc":"Render a top border of the specified width.\n\n```elixir\niex> BackBreeze.Border.line() |> BackBreeze.Border.render_top(10)\n\"┌──────────┐\n\"\n```","ref":"BackBreeze.Border.html#render_top/2"},{"type":"function","title":"BackBreeze.Border.right/1","doc":"Set the right border glyph.","ref":"BackBreeze.Border.html#right/1"},{"type":"function","title":"BackBreeze.Border.top/1","doc":"Set the top border glyph.","ref":"BackBreeze.Border.html#top/1"},{"type":"module","title":"BackBreeze.Box","doc":"A Box is the basic styling primitive used in BackBreeze. If a box has children,\nthey will be rendered first and collapsed down, until a single box remains with\nthe rendered contents.","ref":"BackBreeze.Box.html"},{"type":"function","title":"BackBreeze.Box.new/1","doc":"Create a new `BackBreeze.Box` struct.","ref":"BackBreeze.Box.html#new/1"},{"type":"function","title":"Options - BackBreeze.Box.new/1","doc":"* `:style` - a style map, with any valid keys from `BackBreeze.Style`. The `:border`\n   style can be provided as `:line` for convenience.\n\nAll other options are passed to the `BackBreeze.Box` struct.","ref":"BackBreeze.Box.html#new/1-options"},{"type":"function","title":"BackBreeze.Box.render/2","doc":"Render a box and a tree of its children.","ref":"BackBreeze.Box.html#render/2"},{"type":"function","title":"Options - BackBreeze.Box.render/2","doc":"* `:offset_top` - number of columns to offset from the top.\n  * `:terminal` - the terminal to use. This is used for the terminal size if provided.","ref":"BackBreeze.Box.html#render/2-options"},{"type":"module","title":"BackBreeze.Grid","doc":"Struct for creating a grid to be used by a Box.\n\nBackBreeze.Box.new(\n  style: %{border: :line},\n  display: %BackBreeze.Grid{columns: 1},\n  children: [BackBreeze.Box.new(content: \"Hello\"), BackBreeze.Box.new(content: \"World\")]\n)","ref":"BackBreeze.Grid.html"},{"type":"function","title":"BackBreeze.Grid.__struct__/0","doc":"Create a grid with the specified number of columns.","ref":"BackBreeze.Grid.html#__struct__/0"},{"type":"module","title":"BackBreeze.Style","doc":"Helper module for styling boxes.","ref":"BackBreeze.Style.html"},{"type":"function","title":"BackBreeze.Style.bold/1","doc":"","ref":"BackBreeze.Style.html#bold/1"},{"type":"function","title":"BackBreeze.Style.border/1","doc":"","ref":"BackBreeze.Style.html#border/1"},{"type":"function","title":"BackBreeze.Style.border_bottom/1","doc":"","ref":"BackBreeze.Style.html#border_bottom/1"},{"type":"function","title":"BackBreeze.Style.border_left/1","doc":"","ref":"BackBreeze.Style.html#border_left/1"},{"type":"function","title":"BackBreeze.Style.border_right/1","doc":"","ref":"BackBreeze.Style.html#border_right/1"},{"type":"function","title":"BackBreeze.Style.border_top/1","doc":"","ref":"BackBreeze.Style.html#border_top/1"},{"type":"function","title":"BackBreeze.Style.foreground_color/2","doc":"","ref":"BackBreeze.Style.html#foreground_color/2"},{"type":"function","title":"BackBreeze.Style.height/2","doc":"","ref":"BackBreeze.Style.html#height/2"},{"type":"function","title":"BackBreeze.Style.overflow/2","doc":"","ref":"BackBreeze.Style.html#overflow/2"},{"type":"function","title":"BackBreeze.Style.render/3","doc":"","ref":"BackBreeze.Style.html#render/3"},{"type":"function","title":"BackBreeze.Style.reverse/1","doc":"","ref":"BackBreeze.Style.html#reverse/1"},{"type":"function","title":"BackBreeze.Style.width/2","doc":"","ref":"BackBreeze.Style.html#width/2"},{"type":"module","title":"BackBreeze.Ucwidth","doc":"Module for dealing with variable width glyphs.","ref":"BackBreeze.Ucwidth.html"},{"type":"function","title":"BackBreeze.Ucwidth.width/1","doc":"Return the width of a character when considering glyphs that are more than 1 character wide.\n\n```elixir\niex> BackBreeze.Ucwidth.width(\"H\")\n1\n\niex> BackBreeze.Ucwidth.width(\"🍏\")\n2\n```","ref":"BackBreeze.Ucwidth.html#width/1"},{"type":"module","title":"BackBreeze.Utils","doc":"This module contains functions for dealing with strings containing\nescape codes.","ref":"BackBreeze.Utils.html"},{"type":"function","title":"BackBreeze.Utils.string_length/1","doc":"Return the string length without escape sequences, factoring in glyph width.\n\n```elixir\niex> BackBreeze.Utils.string_length(\"\u001B1;38;5;3m123🍏\")\n5\n```","ref":"BackBreeze.Utils.html#string_length/1"},{"type":"function","title":"BackBreeze.Utils.strip_escape_chars/1","doc":"Strip escape characters from a string.\n\n```elixir\niex> BackBreeze.Utils.strip_escape_chars(\"\u001B1;38;5;3m123🍏\")\n\"123🍏\"\n```","ref":"BackBreeze.Utils.html#strip_escape_chars/1"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}